-- Autor: VADemon, http://steamcommunity.com/id/VADemon/, wademon@yandex.ru
-- UpgradeMe version 1.0a
-- This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License (http://creativecommons.org/licenses/by-nc-sa/3.0/)

ume = {}
addhook("ms100","ume.request")
addhook("clientdata","ume.clientdata")
addhook("objectkill","ume.destroy")
addhook("build","ume.build")
addhook("objectupgrade","ume.upgrade")
addhook("objectdamage","ume.damage")
addhook("startround_prespawn","ume.startround")
onmap = {
	building = {
		--x = {
		--	y = nil --the most performance-friendly solution
		--}
	},
	data = {
		x = {}, y = {},	image = {}
	} --player data
}
ume.upgradelist = { --The Holy Update Tree! Controls the building's upgrades: e.g. 4 (Wall II) can be upgraded into 15 (Super Supply) but only when script's Total reaches 100%
[1] = 3,
[3] = 4,
[4] = 5,
[8] = 11,
[9] = 15,
[11] = 12
}

function ume.request()
	for id in pairs(player(0,"table")) do
		reqcld(id,2)
	end
end

function ume.startround() --clear the table, cuz all buildings were removed
	onmap = {building = {},	data = {x = {}, y = {},	image = {}}}
	for id in pairs(player(0,"table")) do
		parse("hudtxt2 "..id.." "..id.." \"\" 0 0 1")
	end
end

function ume.upgrade(objid,player, progress, full)
	local x = object(objid, "tilex")
	local y = object(objid, "tiley")
	local total = onmap.building[x][y][1]
	local last = onmap.building[x][y][2]
	local current_progress = total + (100 / full * (progress - last))
--	current in %: 100 / full * progress
	if current_progress>=100 then
		if progress~=full then
			ume.buildnew(objid,x,y)
			return true
		else
			if ume.upgradelist[ume.upgradelist[onmap.building[x][y][3]]] then --can the upgraded building to be upgraded? :P in other words: has the upgraded building another upgrade?
				onmap.building[x][y][1] = 0
				onmap.building[x][y][2] = 0
				onmap.building[x][y][3] = ume.upgradelist[onmap.building[x][y][3]]
				--msg("upgrade avaible!")
			else
				--msg("clear it!")
				ume.remove(objid) --clear RAM
			end
			
			return true --oh f*** don't forget that
		end
	end

	onmap.building[x][y][1] = current_progress
	onmap.building[x][y][2] = progress
	--msg("Upgraded! Progress: "..progress.." Full: "..full.." Total: "..total + (100 / full * (progress - last)))
end

function ume.buildnew(objid,x,y) -- Upgrades a building (e.g. Turrel -> Dual Turret)
	local object = object
	local objtype = object(objid, "type")
	local player_team = object(objid, "team")
	local id = object(objid, "player")
	
	parse("killobject "..objid) --Also triggers removing from the list
	if ume.upgradelist[objtype] then ume.add(x,y, objtype) end --Adds the object to the list if it has ability to an upgrade
	parse("spawnobject "..ume.upgradelist[objtype].." "..x.." "..y.." 0 0 "..player_team.." "..id)
	onmap.building[x][y][3] = ume.upgradelist[onmap.building[x][y][3]] --doesn't work without o.O
end

function ume.damage(objid,damage,id)
	if damage>0 then
		local x = object(objid, "tilex")
		local y = object(objid, "tiley")
		onmap.building[x][y][2] = 0
	end
end

function ume.add(x,y, objtype)
	local x = tonumber(x)
	local y = tonumber(y)
	--msg("adding "..objtype)
	if onmap.building[x] then
		if next(onmap.building[x])==nil then
			onmap.building[x] = {
				[y] = {0,0,objtype}
			}
			return true
		else
			onmap.building[x][y] = {0,0,objtype}
		end
		return true
	end
	onmap.building[x] = {
		[y] = {0,0,objtype}
	}
end

function ume.remove(objid)
	--msg("removing id: "..objid)
	local objtype = object(objid, "type")
	if objtype>0 and objtype<15 then
		local x = object(objid, "tilex")
		local y = object(objid, "tiley")
		if onmap.building[x] then
			if next(onmap.building[x])==nil then
				onmap.building[x]=nil
			else
				onmap.building[x][y] = nil
			end
		end
	end
end

function ume.clientdata(id,mode,x,y)

	if mode==2 then
		local tilex = math.ceil(tonumber(x / 32)) - 1
		local tiley = math.ceil(tonumber(y / 32)) - 1
		local x = (x - math.ceil(player(id,"x")) + 320)
		local y = (y - math.ceil(player(id,"y")) + 240)

		local image_id = onmap.data.image[id]

		if onmap.building[tilex] then
			if onmap.building[tilex][tiley] then
				if ume.upgradelist[onmap.building[tilex][tiley][3]] then
					--msg("Success! x: "..tilex.." y: "..tiley)
					local text = "255255000Total: "..math.floor(onmap.building[tilex][tiley][1]).."%"
					
					if image_id then freeimage(image_id) end
					onmap.data.image[id] = image("gfx//upgrademe.png", x+1, y+64, 2, id)
					parse("hudtxt2 "..id.." "..id.." \""..text.."\" "..x.." "..y+56 .." 1")
					
					return true
				end
			else
			--	msg("not y. Current tile: "..tilex.."|"..tiley)
			end
		else
		--	msg("not x. Current tile: "..tilex.."|"..tiley)
		end
		
		if image_id then
			freeimage(image_id)
			parse("hudtxt2 "..id.." "..id.." \"\" 0 0 1")
		end
	end
	
end

function ume.build(id, building_type, x, y, mode, objid)
	if building_type>0 and building_type<15 then
		--msg("Built at! "..x .." and " ..y.." print type: "..type(x))
		ume.add(x,y, building_type)
	end
end

function ume.destroy(id)
	ume.remove(id)
end